//
//  PublishCommand.swift
//  Escape
//
//  Created by Aly Ezz on 10/8/19.
//

import Foundation
import SwiftCLI
import SwiftShell
import FileUtils
import PerfectMarkdown


class CordovaPublishCommand: Command {
    let name = "publish"
    let shortDescription = "Publish the cordova Instabug library to npm, creates a release on Github along with the changelog and updates the dashboard's changelog. The following environment variables are required for the command to run: RELEASE_GITHUB_TOKEN, DASHBOARD_TOKEN, NPM_TOKEN"
    
    func execute() {
        do {
            try GitHub.publishRelease(repoAt: .cordova, versionFrom: .npm)
            try Instabug.publishToDashboard(repoAt: .cordova, versionFrom: .npm, forTargetOS: .cordova, withVersionNumber: nil)
            try PackageManager.publishToNpm()
        } catch {
            print(error)
            exit(1)
        }
    }
}
