//
//  PublishCommand.swift
//  Escape
//
//  Created by Aly Ezz on 10/8/19.
//


import Foundation
import SwiftCLI
import SwiftShell
import FileUtils
import PerfectMarkdown


class FlutterPublishCommand: Command {
    let name = "publish"
    let shortDescription = "Publishes FLutter Release on Github and Dashboard's changelog. . The following environment variables are required for the command to run: RELEASE_GITHUB_TOKEN, DASHBOARD_TOKEN"
    
    func execute() {
        do {
            try GitHub.publishRelease(repoAt: .flutter, versionFrom: .pub)
            try Instabug.publishToDashboard(repoAt: .flutter, versionFrom: .pub, forTargetOS: .flutter, withVersionNumber: nil)
//            try PackageManager.publishToPub()
        } catch {
            print(error)
            exit(1)
        }
    }
}
