import Foundation
import FileUtils

class Constants {
    static let platforms = Platforms()
    static let githubApiBaseURL = "https://api.github.com/repos/Instabug/"
    static let githubBaseRepo = "https://github.com/Instabug/"
    
    static var cacheDirectoryPath: String = {
        var directory = "~/Library/Application\\ Support/com.instabug.escape/"
        directory = Path.expand(directory)
        
        if Path.exists(directory) == false {
            Directory.create(atPath: directory)
        }
        
        return directory
    }()
    
    static func cacheDirectoryPathFor(platform: String) -> String {
        var repoName = ""
        if (platform == "ios") {
            repoName = RepositoryName.iOS.rawValue
        } else {
            repoName = RepositoryName.android.rawValue
        }
        return "\(Constants.cacheDirectoryPath)\(repoName)/"
    }
}


class Platforms {
    let iOS = "ios"
    let android = "android"
}

enum TargetOS: Int {
    case reactNative = 4
    case xamarin = 5
    case cordova = 6
    case flutter = 8
}

enum RepositoryName: String {
    case reactNative = "Instabug-React-Native"
    case xamarin = "instabug-xamarin"
    case cordova = "instabug-cordova"
    case flutter = "Instabug-Flutter"
    case iOS = "Instabug-iOS"
    case android = "android"
}

enum VersionFrom: String {
    case npm = "package.json"
    case pub = "pubspec.yaml"
    case none = ""
}
